%global _hardened_build 1
%{!?_syprefix: %define _syprefix /opt/symas }
%{!?_etcfix: %define _etcfix %{_syprefix}/etc }
%{!?_sylibdir: %define _sylibdir %{_syprefix}/lib }
%{!?_varfix: %define _varfix /var/symas }
%define _cflags "-O2 -g"

Summary:            Utilities from the general purpose cryptography library with TLS implementation
Name:               symas-openssl
Version:            3.0.8
Release:            1%{?dist}
License:            BSD
BuildRequires: gcc
BuildRequires: coreutils, sed, zlib-devel, /usr/bin/cmp
%if 0%{?suse_version}
BuildRequires: perl
%else
BuildRequires: perl-interpreter
%endif
BuildRequires: lksctp-tools-devel
BuildRequires: /usr/bin/rename
BuildRequires: /usr/bin/pod2man
BuildRequires: /usr/sbin/sysctl
BuildRequires: perl(Test::Harness), perl(Test::More), perl(Math::BigInt)
BuildRequires: perl(Module::Load::Conditional), perl(File::Temp)
BuildRequires: perl(Time::HiRes), perl(IPC::Cmd), perl(Pod::Html), perl(Digest::SHA)
BuildRequires: perl(FindBin), perl(lib), perl(File::Compare), perl(File::Copy), perl(bigint)
Requires: coreutils
AutoReqProv:        no
URL:                http://openssl.org
VCS: https://git.symas.net/symas-public/openssl.git
Requires: symas-openssl-libs = %{version}-%{release}
AutoReqProv:        no

Source0: https://www.openssl.org/source/openssl-%{version}.tar.gz

%description
The OpenSSL toolkit provides support for secure communications between
machines. OpenSSL includes a certificate management tool and shared
libraries which provide various cryptographic algorithms and
protocols.

%prep
%setup -n openssl-%{version}

%build
HASHBANGPERL=/usr/bin/perl ./Configure no-idea enable-ec_nistp_64_gcc_128 no-mdc2 no-rc5 no-egd \
-g --debug --prefix=%{_syprefix} --libdir=lib --openssldir=%{_syprefix}/ssl \
shared linux-x86_64 -g -O2
LD_RUN_PATH=%{_sylibdir} make depend
LD_RUN_PATH=%{_sylibdir} make all

%check
make test

%install
make install DESTDIR=%{buildroot} STRIP_OPTS=""
rm -rf %{buildroot}%{_syprefix}/share/doc/openssl/html/
rm -rf %{buildroot}%{_sylibdir}/*.a
install -m 0644 CHANGES.md %{buildroot}%{_syprefix}/share/doc/openssl/
install -m 0644 LICENSE.txt %{buildroot}%{_syprefix}/share/doc/openssl/
install -m 0644 NEWS.md %{buildroot}%{_syprefix}/share/doc/openssl/
install -m 0644 README.md %{buildroot}%{_syprefix}/share/doc/openssl/

%package libs
Summary: OpenSSL Libaries
AutoReqProv:        no

%description libs
The symas-openssl-libs package contains the openssl libraries

%package devel
Summary: openssl Development
Requires: symas-openssl-libs = %{version}-%{release}
AutoReqProv:        no

%description devel
The openssl-devel package contains the linking libraries and include files


%files
%defattr(-,root,root)
%{_syprefix}/bin
%{_syprefix}/ssl
%{_syprefix}/share/man/man1
%{_syprefix}/share/man/man5
%{_syprefix}/share/man/man7

%files libs
%defattr(-,root,root)
%{_sylibdir}/*.so.*
%{_sylibdir}/engines-3
%{_sylibdir}/ossl-modules
%{_syprefix}/share/man/man3
%{_syprefix}/share/doc/openssl

%files devel
%defattr(-,root,root)
%{_syprefix}/include
%{_sylibdir}/pkgconfig/*.pc
%{_sylibdir}/*.so

%changelog
* Thu May 18 2023 Symas Support <support@symas.com> - 3.0.8-1
- OpenSSL 3.0.8-1 release
* Fri Nov 11 2022 Symas Support <support@symas.com> - 1.1.1s-1
- OpenSSL 1.1.1s release
* Thu Jun 23 2022 Symas Support <support@symas.com> - 1.1.1p-1
- OpenSSL 1.1.1p release
* Fri Jun 03 2022 Symas Support <support@symas.com> - 1.1.1o-1
- OpenSSL 1.1.1o release with updated test certificates
- Update expired SCT certificates patch
- ct_test.c Update the epoch time patch
* Tue Nov 16 2021 Symas Support <support@symas.com> - 1.1.1l-2
- Install LICENSE, CHANGES, NEWS, and README files
* Tue Aug 24 2021 Symas Support <support@symas.com> - 1.1.1l-1
- OpenSSL 1.1.1l release
* Mon May 24 2021 Symas Support <support@symas.com> - 1.1.1k-2
- Use odd Symas OpenLDAP Gold path for SSL dir
* Tue Apr 6 2021 Symas Support <support@symas.com> - 1.1.1k-1
- initial packaging
